import greenfoot.*; // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.Random;
import java.lang.Math;
/**
 * Write a description of class BattleScreen here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class BattleScreen  extends Actor
{
    /**
     * Act - do whatever the BattleScreen wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private final static GreenfootImage battleImages[] = new GreenfootImage[]{new GreenfootImage("Battle01.png"), new GreenfootImage("Battle02.png")};
    private final static String attentions[] = new String[]{
      new String("Confronted by: "), 
      new String("Hero attacked: "),
      new String("Monster attacked: "),
      new String("Hero died!"),
      new String("Monster died!"),
    };
    private Hero hero;
    private Monster monster;
    private Button Attack, Flee;
    private Textbox HeroHP, MonsterHP;
    private boolean fighting, isAttacking = false, isHero = true;
    private int heroStats[];
    private int heroImg = 0, monsterImg = 0, backImg = 0;
    private int monsterStats[];
    private long startTime;
    private Random randNumber;
    public BattleScreen(){
        HeroHP = new Textbox("HP: ");
        MonsterHP = new Textbox("HP: ");
        Attack = new Button("Attack", 0, 0);
        Flee = new Button("Flee", 0, 0);
        randNumber = new Random();
    }
    public void setupBattle(Hero heroRef, Monster monstRef){
        //Battle Setup
        hero = heroRef;
        monster = monstRef;
        backImg = randNumber.nextInt(battleImages.length);
        heroStats = hero.getStats();
        monsterStats = monster.getStats();
        HeroHP.caption("HP: "+heroStats[1]);
        MonsterHP.caption("HP: "+monsterStats[1]);

        fighting = true;
    }
    public void addedToWorld(World world){
        getImage().scale(world.getWidth(), world.getHeight());
        setLocation(320, 208);
        refresh();
        world.addObject(HeroHP, 150, 40);
        world.addObject(MonsterHP, 510, 40);
        world.addObject(Attack, 100, 250);
        world.addObject(Flee, 100, 300);
        world.addObject(new FastAttention(attentions[0] + monster.getName()), 100, 50);
    }
    public void removeFromWorld(){
        World world = getWorld();
        world.removeObject(HeroHP);
        world.removeObject(MonsterHP);
        world.removeObject(Attack);
        world.removeObject(Flee);
    }
    public boolean isFighting(){
        return fighting;
    }
    public void refresh(){
        getImage().clear();
        getImage().drawImage(battleImages[backImg], 0, 0);
        getImage().drawImage(hero.getBattleImage()[heroImg], 25, 320);
        getImage().drawImage(monster.getBattleImage(), 525, 340);
    }
    public void act() 
    {
        // Add your action code here.
        if(isAttacking ){
            long nowTime = System.currentTimeMillis();
            int frame =  (int)(Math.floor(nowTime-startTime)/25);
            if(isHero){
                    if(frame < hero.getBattleImage().length){
                         heroImg = frame;
                    }else{
                         int heroAttack = hero.attack();
                         monster.attacked(heroAttack);
                         getWorld().addObject(new FastMessage(attentions[1]+heroAttack), 510, 50);
                         monsterStats = monster.getStats();
                         MonsterHP.caption("HP: "+monsterStats[1]);
                         heroImg = 0;
                         isHero = false;
                    }
                    refresh();
            }else
            if(monster.isAlive()){
                //Monster
                    int monsterAttack = monster.attack();
                    hero.attacked(monsterAttack);
                    getWorld().addObject(new FastMessage(attentions[2]+monsterAttack), 20, 70);
                    heroStats = hero.getStats();
                    HeroHP.caption("HP: "+heroStats[1]);
                    if(!hero.isAlive()){
                        fighting = false;
                        System.out.println("Hero Dead");
                        getWorld().addObject(new FastMessage(attentions[3]+100), 250, 50);
                    }
                    isAttacking = false;
            }else{
                    fighting = false;
                    hero.raiseExperience(monster.expGained());
                    System.out.println("Monster Dead");
                    getWorld().addObject(new FastMessage(attentions[4]), 250, 70);
                    isAttacking = false;
            }
        }else
        if(Greenfoot.mouseClicked(Attack) && monster.isAlive() && hero.isAlive() && !isAttacking){
                startTime = System.currentTimeMillis();
                isHero = true;
                isAttacking = true;
        }else
        if(Greenfoot.mouseClicked(Flee) && !isAttacking){
            System.out.println("Flee");
            fighting = false;
        }
    }    
}
